
# Taking the recipe returns the array of sdates to be loaded
# both for the hcst and fcst.
dates2load <- function(recipe, logger){

  recipe <- recipe$Analysis$Time
  
  # hcst dates
  file_dates <- outer(strtoi(recipe$hcst_start):strtoi(recipe$hcst_end),
                      recipe$sdate$fcst_sday,paste,sep="")
  file_dates <- add_dims(file_dates, "hcst")
  
  # fcst dates (if fcst_year empty it creates an empty object)
  if (! is.null(recipe$sdate$fcst_year)){
    file_dates.fcst <- outer(recipe$sdate$fcst_year,recipe$sdate$fcst_sday,paste,sep="")
    file_dates.fcst <- add_dims(file_dates.fcst, "fcst")
  } else {
    file_dates.fcst <- NULL
    info(logger,
         paste("fcst_year empty in the recipe, creating empty fcst object..."))
  }

  return(list(hcst=file_dates,fcst=file_dates.fcst))

}

# adds the correspondent dims to each sdate array
add_dims <- function(data, type){

  if (type == "hcst"){
    default_dims <- c(sday = 1, sweek = 1, 
                      syear = dim(data)[1], srun = dim(data)[2])
  } else {
    default_dims <- c(fcst_year = dim(data)[1], srun = dim(data)[2])
  }

  default_dims[names(dim(data))] <- dim(data)
  dim(data) <- default_dims
  return(data)

 }

